## GstPushSrc

GstPushSrc — Base class for push based source elements

## Types and Values

struct | GstPushSrc
struct | GstPushSrcClass

## Object Hierarchy

        GObject
        ╰── GInitiallyUnowned
            ╰── GstObject
                ╰── GstElement
                    ╰── GstBaseSrc
                        ╰── GstPushSrc

## Includes

    #include <gst/base/gstpushsrc.h>

## Description

This class is mostly useful for elements that cannot do random access, or at least very slowly. The source usually prefers to push out a fixed size buffer.

Subclasses usually operate in a format that is different from the default GST_FORMAT_BYTES format of GstBaseSrc.

Classes extending this base class will usually be scheduled in a push based mode. If the peer accepts to operate without offsets and within the limits of the allowed block size, this class can operate in getrange based mode automatically. To make this possible, the subclass should implement and override the SCHEDULING query.

The subclass should extend the methods from the baseclass in addition to the ::create method.

Seeking, flushing, scheduling and sync is all handled by this base class.

## Functions

## Types and Values

### struct GstPushSrc

    struct GstPushSrc;

The opaque GstPushSrc data structure.

### struct GstPushSrcClass

    struct GstPushSrcClass {
      GstBaseSrcClass parent_class;

      /* ask the subclass to create a buffer, the default implementation
       * uses alloc and fill */
      GstFlowReturn (*create) (GstPushSrc *src, GstBuffer **buf);
      /* allocate memory for a buffer */
      GstFlowReturn (*alloc)  (GstPushSrc *src, GstBuffer **buf);
      /* ask the subclass to fill a buffer */
      GstFlowReturn (*fill)   (GstPushSrc *src, GstBuffer *buf);
    };

## See Also

GstBaseSrc